(function (exports) {
'use strict';

function __$styleInject(css) {
    if (!css) return;

    if (typeof window == 'undefined') return;
    var style = document.createElement('style');
    style.setAttribute('media', 'screen');

    style.innerHTML = css;
    document.head.appendChild(style);
    return css;
}
var classCallCheck = function (instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
};

var createClass = function () {
  function defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  return function (Constructor, protoProps, staticProps) {
    if (protoProps) defineProperties(Constructor.prototype, protoProps);
    if (staticProps) defineProperties(Constructor, staticProps);
    return Constructor;
  };
}();





var defineProperty = function (obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
};

var _extends = Object.assign || function (target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i];

    for (var key in source) {
      if (Object.prototype.hasOwnProperty.call(source, key)) {
        target[key] = source[key];
      }
    }
  }

  return target;
};

var get$1 = function get$1(object, property, receiver) {
  if (object === null) object = Function.prototype;
  var desc = Object.getOwnPropertyDescriptor(object, property);

  if (desc === undefined) {
    var parent = Object.getPrototypeOf(object);

    if (parent === null) {
      return undefined;
    } else {
      return get$1(parent, property, receiver);
    }
  } else if ("value" in desc) {
    return desc.value;
  } else {
    var getter = desc.get;

    if (getter === undefined) {
      return undefined;
    }

    return getter.call(receiver);
  }
};

var inherits = function (subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      enumerable: false,
      writable: true,
      configurable: true
    }
  });
  if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
};









var objectWithoutProperties = function (obj, keys) {
  var target = {};

  for (var i in obj) {
    if (keys.indexOf(i) >= 0) continue;
    if (!Object.prototype.hasOwnProperty.call(obj, i)) continue;
    target[i] = obj[i];
  }

  return target;
};

var possibleConstructorReturn = function (self, call) {
  if (!self) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return call && (typeof call === "object" || typeof call === "function") ? call : self;
};



var set$1 = function set$1(object, property, value, receiver) {
  var desc = Object.getOwnPropertyDescriptor(object, property);

  if (desc === undefined) {
    var parent = Object.getPrototypeOf(object);

    if (parent !== null) {
      set$1(parent, property, value, receiver);
    }
  } else if ("value" in desc && desc.writable) {
    desc.value = value;
  } else {
    var setter = desc.set;

    if (setter !== undefined) {
      setter.call(receiver, value);
    }
  }

  return value;
};

var AMPClassList = function () {
  function AMPClassList(component) {
    var tokens = arguments.length <= 1 || arguments[1] === undefined ? [] : arguments[1];
    classCallCheck(this, AMPClassList);

    this.component = component;
    this.tokens = tokens;
  }

  createClass(AMPClassList, [{
    key: 'add',
    value: function add(token) {
      if (this.contains(token)) return;
      this.tokens.push(token);
    }
  }, {
    key: 'contains',
    value: function contains(token) {
      return this.tokens.indexOf(token) !== -1;
    }
  }, {
    key: 'item',
    value: function item(index) {
      return this.tokens[index] || null;
    }
  }, {
    key: 'remove',
    value: function remove(token) {
      var i = this.tokens.indexOf(token);
      if (i === -1) return;
      this.tokens.splice(i, 1);
    }
  }, {
    key: 'toggle',
    value: function toggle(token) {
      if (this.contains(token)) {
        this.remove(token);
      } else {
        this.add(token);
      }
    }
  }, {
    key: 'update',
    value: function update(tokenMap) {
      for (var token in tokenMap) {
        if (tokenMap[token]) {
          this.add(token);
        } else {
          this.remove(token);
        }
      }

      var className = this.toString();
      if (className != this.component.state.className) this.component.setState({ className: className });
    }
  }, {
    key: 'toString',
    value: function toString() {
      return this.tokens.join(' ');
    }
  }]);
  return AMPClassList;
}();

var AMPComponent = function (_React$Component) {
  inherits(AMPComponent, _React$Component);

  function AMPComponent(props) {
    classCallCheck(this, AMPComponent);

    var _this = possibleConstructorReturn(this, (AMPComponent.__proto__ || Object.getPrototypeOf(AMPComponent)).call(this, props));

    _this.state = {};
    _this.classList = new AMPClassList(_this, _this.props.classList);
    return _this;
  }

  createClass(AMPComponent, [{
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate(nextProps, nextState) {
      var state = this.state;
      var props = this.props;

      if (nextState != null) {
        for (var key in nextState) {
          if (nextState[key] != state[key]) {
            return true;
          }
        }
      }

      // TODO: Is this needed?
      if (nextProps != null) {
        for (var _key in nextProps) {
          if (nextProps[_key] != props[_key]) {
            return true;
          }
        }
      }

      return false;
    }
  }, {
    key: "componentWillMount",
    value: function componentWillMount() {
      var _this2 = this;

      this.playerEventMap.forEach(function (event) {
        _this2[event.key] = _this2[event.key].bind(_this2);
        _this2.player.addEventListener(event.type, _this2[event.key]);
      });
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      var _this3 = this;

      this.playerEventMap.forEach(function (event) {
        _this3.player.removeEventListener(event.type, _this3[event.key]);
      });
    }
  }, {
    key: "render",
    value: function render() {
      return React.createElement(
        "div",
        _extends({ ref: "element" }, this.propsList, { className: this.className }),
        this.props.children
      );
    }
  }, {
    key: "player",
    get: function get() {
      return this.props.player;
    }
  }, {
    key: "config",
    get: function get() {
      return this.props.config;
    }
  }, {
    key: "className",
    get: function get() {
      var className = this.props.className || "";
      className += " " + this.classList;

      return className;
    }
  }, {
    key: "element",
    get: function get() {
      return this.refs.element;
    }
  }, {
    key: "playerEventMap",
    get: function get() {
      var events = [];
      var regexp = /^on/;
      var props = Object.getOwnPropertyNames(Object.getPrototypeOf(this));

      if (this.player == null) return events;

      props.forEach(function (prop) {
        if (!regexp.test(prop)) return;
        events.push({ key: prop, type: prop.replace(regexp, "") });
      });

      return events;
    }
  }, {
    key: "propsList",
    get: function get() {
      var _props = this.props;
      var player = _props.player;
      var config = _props.config;
      var className = _props.className;
      var classList = _props.classList;
      var props = objectWithoutProperties(_props, ["player", "config", "className", "classList"]);

      return props;
    }
  }]);
  return AMPComponent;
}(React.Component);

var AMPContainer = function (_AMPComponent) {
  inherits(AMPContainer, _AMPComponent);

  function AMPContainer(props) {
    classCallCheck(this, AMPContainer);

    var _this = possibleConstructorReturn(this, (AMPContainer.__proto__ || Object.getPrototypeOf(AMPContainer)).call(this, props));

    _this.state.components = [];
    return _this;
  }

  createClass(AMPContainer, [{
    key: "addComponent",
    value: function addComponent(component) {
      var components = this.state.components.slice();
      components.push(component);
      this.setState({ components: components });
    }
  }, {
    key: "removeComponent",
    value: function removeComponent(component) {
      var components = this.state.components.filter(function (item) {
        return item != component;
      });
      this.setState({ components: components });
    }
  }, {
    key: "render",
    value: function render() {
      return React.createElement(
        "div",
        _extends({ ref: "element" }, this.propsList, { className: this.className }),
        this.props.children,
        this.state.components
      );
    }
  }]);
  return AMPContainer;
}(AMPComponent);

var PlayPause = function (_AMPComponent) {
  inherits(PlayPause, _AMPComponent);

  function PlayPause() {
    classCallCheck(this, PlayPause);
    return possibleConstructorReturn(this, (PlayPause.__proto__ || Object.getPrototypeOf(PlayPause)).apply(this, arguments));
  }

  createClass(PlayPause, [{
    key: "clickHandler",
    value: function clickHandler() {
      var player = this.player;
      switch (player.playState) {
        case "ended":
          player.currentTime = 0;
        case "ready":
        case "paused":
          player.play();
          break;

        default:
          player.pause();
          break;
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      return React.createElement("button", { className: "amp-icon amp-playpause", onClick: function onClick() {
          return _this2.clickHandler();
        } });
    }
  }]);
  return PlayPause;
}(AMPComponent);

var Utils = function () {
  function Utils() {
    classCallCheck(this, Utils);
  }

  createClass(Utils, null, [{
    key: "formatTimecode",


    /**
     * Takes a time in seconds and converts it to timecode.
     * 
     * @param   {Number}  time  The time in seconds to be formatted.
     * @return  {String}  A SMTP formatted string.
     */
    value: function formatTimecode(time, duration) {
      time = parseInt(time);
      if (isNaN(time)) {
        return "00:00";
      }
      var strTime = Utils.formatZeroFill(time % 60);
      time = parseInt(time / 60);
      strTime = Utils.formatZeroFill(time % 60) + ":" + strTime;
      time = parseInt(time / 60);
      if (time > 0) {
        strTime = Utils.formatZeroFill(time) + ":" + strTime;
      }
      if (duration >= 3600 && strTime.length === 5) {
        strTime = "00:" + strTime;
      }
      return strTime;
    }

    /**
     * Converts a time in seconds to a string and adds a zero in front of any number lower than 10.
     * 
     * @param {Number} time The number to be zero filled.
     */

  }, {
    key: "formatZeroFill",
    value: function formatZeroFill(time) {
      var str = time.toString();
      if (time < 10) {
        str = "0" + str;
      }
      return str;
    }

    /**
     * @param {Number} number 
     *    The number to be rounded.
     *
     * @param {Number} precision 
     *    The level of precision. Positive 1 would round to 1 decimal place and -1 would round to the tens.
     *
     * @return {Number}
     *    The rounded number.
     */

  }, {
    key: "round",
    value: function round(number, precision) {
      var factor = Math.pow(10, precision);
      return Math.round(number * factor) / factor;
    }
  }, {
    key: "getElementOffset",
    value: function getElementOffset(element) {
      var root = arguments.length <= 1 || arguments[1] === undefined ? document.fullscreenElement || document.webkitFullscreenElement || document.mozFullscreenElement : arguments[1];

      var left = 0;
      var top = 0;
      var width = element.offsetWidth;
      var height = element.offsetHeight;
      var scrollLeft = 0;
      var scrollTop = 0;

      while (element && element !== root) {
        if (element.tagName === "BODY") {
          scrollLeft = element.scrollLeft || document.documentElement.scrollLeft;
          scrollTop = element.scrollTop || document.documentElement.scrollTop;
          left += element.offsetLeft - scrollLeft + element.clientLeft;
          top += element.offsetTop - scrollTop + element.clientTop;
        } else {
          left += element.offsetLeft - element.scrollLeft + element.clientLeft;
          top += element.offsetTop - element.scrollTop + element.clientTop;
        }
        element = element.offsetParent;
      }

      return { left: left, top: top, width: width, height: height };
    }
  }, {
    key: "getEventPos",
    value: function getEventPos(event) {
      return {
        x: event.clientX || event.targetTouches[0].clientX,
        y: event.clientY || event.targetTouches[0].clientY
      };
    }
  }]);
  return Utils;
}();

var CurrentTime = function (_AMPComponent) {
  inherits(CurrentTime, _AMPComponent);

  function CurrentTime(props) {
    classCallCheck(this, CurrentTime);

    var _this = possibleConstructorReturn(this, (CurrentTime.__proto__ || Object.getPrototypeOf(CurrentTime)).call(this, props));

    _this.state.currentTime = 0;
    return _this;
  }

  createClass(CurrentTime, [{
    key: "ontimeupdate",
    value: function ontimeupdate() {
      this.setState({ currentTime: Math.round(this.player.currentTime) });
    }
  }, {
    key: "render",
    value: function render() {
      return React.createElement(
        "span",
        { className: "amp-current-time" },
        Utils.formatTimecode(this.state.currentTime, this.props.player.duration)
      );
    }
  }]);
  return CurrentTime;
}(AMPComponent);

var Duration = function (_AMPComponent) {
  inherits(Duration, _AMPComponent);

  function Duration(props) {
    classCallCheck(this, Duration);

    var _this = possibleConstructorReturn(this, (Duration.__proto__ || Object.getPrototypeOf(Duration)).call(this, props));

    _this.state.duration = props.player.duration;
    return _this;
  }

  createClass(Duration, [{
    key: "ondurationchange",
    value: function ondurationchange() {
      this.setState({ duration: Math.round(this.player.duration) });
    }
  }, {
    key: "render",
    value: function render() {
      console.log("Duration.render");
      return React.createElement(
        "span",
        { className: "amp-duration" },
        Utils.formatTimecode(this.state.duration, this.state.duration)
      );
    }
  }]);
  return Duration;
}(AMPComponent);

var Slider = function (_AMPComponent) {
  inherits(Slider, _AMPComponent);

  function Slider(props) {
    classCallCheck(this, Slider);

    var _this = possibleConstructorReturn(this, (Slider.__proto__ || Object.getPrototypeOf(Slider)).call(this, props));

    _this.state.value = 0;
    _this.state.time = 0;
    return _this;
  }

  createClass(Slider, [{
    key: "clickHandler",
    value: function clickHandler(event) {
      var offset = Utils.getElementOffset(this.refs.slider);
      var pos = Utils.getEventPos(event);
      this.value = (pos.x - offset.left) / offset.width;
    }
  }, {
    key: "valueChanged",
    value: function valueChanged() {}
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var value = Utils.round(this.value * 100, 2) + "%";
      return React.createElement(
        "div",
        { ref: "slider", className: "amp-slider " + this.props.className, onClick: function onClick(event) {
            return _this2.clickHandler(event);
          } },
        React.createElement("div", { className: "amp-value", style: { width: value } }),
        React.createElement("div", { className: "amp-handle", style: { left: value } }),
        React.createElement(AMPContainer, { ref: "markers", className: "amp-markers" }),
        React.createElement(
          "div",
          { className: "amp-text", style: { left: value } },
          this.state.time
        )
      );
    }
  }, {
    key: "value",
    set: function set(value) {
      if (this.value == value) return;

      this.setState({ value: value });
      this.valueChanged(value);
    },
    get: function get() {
      return this.state.value;
    }
  }, {
    key: "markers",
    get: function get() {
      return this.refs.markers;
    }
  }]);
  return Slider;
}(AMPComponent);

var Progress = function (_Slider) {
  inherits(Progress, _Slider);

  function Progress() {
    classCallCheck(this, Progress);
    return possibleConstructorReturn(this, (Progress.__proto__ || Object.getPrototypeOf(Progress)).apply(this, arguments));
  }

  createClass(Progress, [{
    key: "updateValue",
    value: function updateValue() {
      this.setState({ value: this.player.currentTime / this.player.duration });
    }
  }, {
    key: "ontimeupdate",
    value: function ontimeupdate() {
      this.updateValue();
    }
  }, {
    key: "ondurationchange",
    value: function ondurationchange() {
      this.updateValue();
    }
  }, {
    key: "valueChanged",
    value: function valueChanged(value) {
      this.player.currentTime = value * this.player.duration;
    }
  }]);
  return Progress;
}(Slider);

var Volume = function (_Slider) {
  inherits(Volume, _Slider);

  function Volume(props) {
    classCallCheck(this, Volume);

    var _this = possibleConstructorReturn(this, (Volume.__proto__ || Object.getPrototypeOf(Volume)).call(this, props));

    _this.state.value = _this.player.volume;
    return _this;
  }

  createClass(Volume, [{
    key: "onvolumechange",
    value: function onvolumechange() {
      this.setState({ value: this.player.volume });
    }
  }, {
    key: "valueChanged",
    value: function valueChanged(value) {
      this.player.volume = value;
    }
  }]);
  return Volume;
}(Slider);

var Mute = function (_AMPComponent) {
  inherits(Mute, _AMPComponent);

  function Mute(props) {
    classCallCheck(this, Mute);

    var _this = possibleConstructorReturn(this, (Mute.__proto__ || Object.getPrototypeOf(Mute)).call(this, props));

    _this.state.level = "";
    return _this;
  }

  createClass(Mute, [{
    key: "clickHandler",
    value: function clickHandler() {
      var player = this.player;
      player.muted = !player.muted;
    }
  }, {
    key: "onvolumechange",
    value: function onvolumechange() {
      var volume = this.player.volume;
      var level = "";

      if (volume == 0) {
        level = "amp-muted";
      } else if (volume < 0.5) {
        level = "amp-low";
      }

      this.setState({ level: level });
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      return React.createElement("button", { className: "amp-icon amp-mute " + this.state.level, onClick: function onClick() {
          return _this2.clickHandler();
        } });
    }
  }]);
  return Mute;
}(AMPComponent);

var ClosedCaptioning = function (_AMPComponent) {
  inherits(ClosedCaptioning, _AMPComponent);

  function ClosedCaptioning(props) {
    classCallCheck(this, ClosedCaptioning);

    var _this = possibleConstructorReturn(this, (ClosedCaptioning.__proto__ || Object.getPrototypeOf(ClosedCaptioning)).call(this, props));

    _this._showing = true;
    return _this;
  }

  createClass(ClosedCaptioning, [{
    key: "update",
    value: function update() {
      var tracks = this.player.textTracks;
      var len = tracks.length;
      for (var i = 0, track; i < len; i++) {
        track = tracks[i];
        if (track.kind != "captions") continue;
        track.mode = this.showing ? "showing" : "hidden";
      }
    }
  }, {
    key: "clickHandler",
    value: function clickHandler() {
      this.showing = !this.showing;
      this.update();
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      return React.createElement("button", { className: "amp-icon amp-cc " + this.classList, onClick: function onClick() {
          return _this2.clickHandler();
        } });
    }
  }, {
    key: "showing",
    get: function get() {
      return this._showing;
    },
    set: function set(value) {
      this._showing = value;
      this.classList.update({ "amp-off": !this._showing });
    }
  }]);
  return ClosedCaptioning;
}(AMPComponent);

var Fullscreen = function (_AMPComponent) {
  inherits(Fullscreen, _AMPComponent);

  function Fullscreen(props) {
    classCallCheck(this, Fullscreen);

    var _this = possibleConstructorReturn(this, (Fullscreen.__proto__ || Object.getPrototypeOf(Fullscreen)).call(this, props));

    _this.event = document.onwebkitfullscreenchange !== undefined ? "webkitfullscreenchange" : document.onmozfullscreenchange !== undefined ? "mozfullscreenchange" : "fullscreenchange";
    _this.requestFullscreen = (_this.player.container.requestFullscreen || _this.player.container.webkitRequestFullscreen).bind(_this.player.container);
    _this.exitFullscreen = (document.exitFullscreen || document.webkitExitFullscreen).bind(document);
    _this.fullscreenchange = _this.fullscreenchange.bind(_this);
    return _this;
  }

  createClass(Fullscreen, [{
    key: "fullscreenchange",
    value: function fullscreenchange() {
      this.classList.update({ "amp-full": this.fullscreenElement != null });
    }
  }, {
    key: "componentWillMount",
    value: function componentWillMount() {
      get$1(Fullscreen.prototype.__proto__ || Object.getPrototypeOf(Fullscreen.prototype), "componentWillMount", this).call(this);
      document.addEventListener(this.event, this.fullscreenchange);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      get$1(Fullscreen.prototype.__proto__ || Object.getPrototypeOf(Fullscreen.prototype), "componentWillUnmount", this).call(this);
      document.removeEventListener(this.event, this.fullscreenchange);
    }
  }, {
    key: "clickHandler",
    value: function clickHandler() {
      if (this.fullscreenElement == null) {
        this.requestFullscreen();
      } else {
        this.exitFullscreen();
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      return React.createElement("button", { ref: this.ref, className: "amp-icon amp-fullscreen " + this.classList, onClick: function onClick() {
          return _this2.clickHandler();
        } });
    }
  }, {
    key: "fullscreenElement",
    get: function get() {
      return document.fullscreenElement || document.webkitFullscreenElement;
    }
  }]);
  return Fullscreen;
}(AMPComponent);

var Panel = function (_AMPComponent) {
  inherits(Panel, _AMPComponent);

  function Panel(props) {
    classCallCheck(this, Panel);

    var _this = possibleConstructorReturn(this, (Panel.__proto__ || Object.getPrototypeOf(Panel)).call(this, props));

    _this.closeHandler = _this.closeHandler.bind(_this);
    return _this;
  }

  createClass(Panel, [{
    key: "closeHandler",
    value: function closeHandler(event) {
      if (this.element.contains(event.target)) return;

      this.open = false;
      document.removeEventListener("click", this.closeHandler);
    }
  }, {
    key: "toggle",
    value: function toggle() {
      this.open = !this.open;
    }
  }, {
    key: "open",
    set: function set(value) {
      if (value == this._open) return;

      this._open = value;
      this.classList.update({ "amp-open": this._open });

      if (this._open) {
        document.addEventListener("click", this.closeHandler);
        if (this.props.onopen) this.props.onopen(this);
      } else {
        if (this.props.onclose) this.props.onclose(this);
      }
    },
    get: function get() {
      return this._open;
    }
  }, {
    key: "propsList",
    get: function get() {
      var _babelHelpers$get = get$1(Panel.prototype.__proto__ || Object.getPrototypeOf(Panel.prototype), "propsList", this);

      var onclose = _babelHelpers$get.onclose;
      var onopen = _babelHelpers$get.onopen;
      var props = objectWithoutProperties(_babelHelpers$get, ["onclose", "onopen"]);

      return props;
    }
  }]);
  return Panel;
}(AMPComponent);

var UI = function (_AMPComponent) {
  inherits(UI, _AMPComponent);

  function UI(props) {
    classCallCheck(this, UI);

    var _this = possibleConstructorReturn(this, (UI.__proto__ || Object.getPrototypeOf(UI)).call(this, props));

    _this._playstate = "ready";
    _this._activeLoced = false;
    _this.state.media = {};
    _this.timeout = null;
    return _this;
  }

  createClass(UI, [{
    key: "onmediachange",
    value: function onmediachange(event) {
      var media = this.player.media;
      this.container.classList.update({ "amp-text-tracks": media.tracks && media.tracks.length });
      this.setState({ media: media });
    }
  }, {
    key: "onplaystatechange",
    value: function onplaystatechange(event) {
      var state = event.detail.value;
      if (state == "waiting") return;
      this.playstate = state;
    }
  }, {
    key: "onplaying",
    value: function onplaying() {
      this.waiting = false;
    }
  }, {
    key: "onseeking",
    value: function onseeking() {
      this.waiting = true;
    }
  }, {
    key: "onseeked",
    value: function onseeked() {
      this.waiting = false;
    }
  }, {
    key: "onwaiting",
    value: function onwaiting() {
      this.waiting = true;
    }
  }, {
    key: "togglePlayPause",
    value: function togglePlayPause() {
      if (this.player.paused) {
        this.player.play();
      } else {
        this.player.pause();
      }
    }
  }, {
    key: "mouseenter",
    value: function mouseenter() {
      clearTimeout(this.timeout);
      this.container.classList.update({ "amp-active": true, "amp-inactive": false });
    }
  }, {
    key: "mouseleave",
    value: function mouseleave() {
      var _this2 = this;

      if (this.activeLocked == true || this.playstate == "ready" || this.playstate == "paused") return;

      this.container.classList.update({ "amp-active": false, "amp-inactive": true });
      this.timeout = setTimeout(function () {
        _this2.container.classList.update({ "amp-inactive": false });
      }, this.config.autoHide * 1000);
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;

      console.log("UI.render");
      return React.createElement(
        AMPContainer,
        { ref: "container", className: "amp-ui", classList: ["amp-ready", "amp-active"], onMouseEnter: function onMouseEnter() {
            return _this3.mouseenter();
          }, onMouseLeave: function onMouseLeave() {
            return _this3.mouseleave();
          } },
        React.createElement("div", { className: "amp-interactive", onClick: function onClick() {
            return _this3.togglePlayPause();
          } }),
        React.createElement("img", { className: "amp-poster", src: this.state.media.poster }),
        React.createElement("button", { className: "amp-icon amp-pause-overlay", onClick: function onClick() {
            return _this3.player.play();
          } }),
        React.createElement(Progress, { ref: "progress", className: "amp-progress", player: this.player }),
        React.createElement(
          AMPContainer,
          { ref: "controls", className: "amp-controls" },
          React.createElement(PlayPause, { player: this.player }),
          React.createElement(
            "div",
            { className: "amp-time-display" },
            React.createElement(CurrentTime, { player: this.player }),
            React.createElement("span", { className: "amp-time-separator" }),
            React.createElement(Duration, { player: this.player })
          ),
          React.createElement(Mute, { player: this.player }),
          React.createElement(Volume, { className: "amp-volume", player: this.player }),
          React.createElement("div", { className: "amp-spacer" }),
          React.createElement("div", { className: "amp-spacer" }),
          React.createElement(ClosedCaptioning, { player: this.player }),
          React.createElement("button", { className: "amp-icon amp-settings", onClick: function onClick() {
              return _this3.refs.settings.toggle();
            } }),
          React.createElement(Fullscreen, { player: this.player })
        ),
        React.createElement(
          Panel,
          { ref: "settings", className: "amp-settings-panel", onopen: function onopen() {
              return _this3.activeLocked = true;
            }, onclose: function onclose() {
              return _this3.activeLocked = false;
            } },
          React.createElement(
            "div",
            null,
            React.createElement(
              "select",
              null,
              React.createElement(
                "option",
                { value: "en" },
                "English"
              ),
              React.createElement(
                "option",
                { value: "es" },
                "Spanish"
              )
            ),
            React.createElement(
              "button",
              null,
              "Options"
            )
          )
        )
      );
    }
  }, {
    key: "container",
    get: function get() {
      return this.refs.container;
    }
  }, {
    key: "controls",
    get: function get() {
      return this.refs.controls;
    }
  }, {
    key: "playstate",
    set: function set(value) {
      var _updates;

      if (this._playstate == value) return;

      var updates = (_updates = {}, defineProperty(_updates, "amp-" + this._playstate, false), defineProperty(_updates, "amp-" + value, true), _updates);
      this._playstate = value;
      this.container.classList.update(updates);
    },
    get: function get() {
      return this._playstate;
    }
  }, {
    key: "waiting",
    set: function set(value) {
      if (this._waiting == value) return;
      this._waiting = value;
      this.container.classList.update({ "amp-waiting": this._waiting });
    }
  }]);
  return UI;
}(AMPComponent);

var AMPReactUI = function () {
  function AMPReactUI(player) {
    var config = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];
    classCallCheck(this, AMPReactUI);

    this._player = player;
    this._config = config;

    // polyfill missing AMP APIs   
    // create container
    var element = document.createElement("div");
    element.className = "amp-react";
    player.getViewComponent().appendChild(element);
    this._container = element;

    this.render();
  }

  createClass(AMPReactUI, [{
    key: "render",
    value: function render() {
      this.ui = ReactDOM.render(React.createElement(UI, { player: this._player, config: this._config }), this._container);
    }
  }, {
    key: "destroy",
    value: function destroy() {
      ReactDOM.unmountComponentAtNode(this._container);
    }
  }]);
  return AMPReactUI;
}();

exports.AMPReactUI = AMPReactUI;
exports.AMPComponent = AMPComponent;
exports.AMPContainer = AMPContainer;
exports.AMPClassList = AMPClassList;

}((this.ampreactui = this.ampreactui || {})));
//# sourceMappingURL=amp.ui.js.map
